package hideandseek.commands;

import hideandseek.Arena;
import java.util.Map;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import hideandseek.Customization;
import hideandseek.Config;
import org.bukkit.ChatColor;
import hideandseek.utils.Utils;
import org.bukkit.entity.Player;
import hideandseek.HideAndSeek;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import hideandseek.commands.admin.TestCommand;
import hideandseek.commands.admin.EditModeCommand;
import hideandseek.commands.admin.ReloadCommand;
import hideandseek.commands.admin.CheckCommand;
import hideandseek.commands.admin.PowerupCommand;
import hideandseek.commands.admin.SetModifierCommand;
import hideandseek.commands.admin.ExpCommand;
import hideandseek.commands.admin.CoinsCommand;
import hideandseek.commands.admin.StopCommand;
import hideandseek.commands.admin.StartCommand;
import hideandseek.commands.admin.ResetCommand;
import hideandseek.commands.admin.EditCommand;
import hideandseek.commands.admin.SetGlobalLobby;
import hideandseek.commands.admin.SetLocationCommand;
import hideandseek.commands.admin.DeleteCommand;
import hideandseek.commands.admin.CreateCommand;
import hideandseek.commands.admin.AdminCommand;
import hideandseek.commands.user.AutoJoinCommand;
import hideandseek.commands.user.LeaveCommand;
import hideandseek.commands.user.JoinCommand;
import hideandseek.commands.user.LobbyCommand;
import hideandseek.commands.user.StatsCommand;
import hideandseek.commands.user.ListCommand;
import java.util.HashMap;
import org.bukkit.command.TabCompleter;
import org.bukkit.command.CommandExecutor;

public class MainCommand implements CommandExecutor, TabCompleter
{
    HashMap<String, SubCommand> commands;
    
    public MainCommand() {
        (this.commands = new HashMap<String, SubCommand>()).put("list", (SubCommand)new ListCommand());
        this.commands.put("stats", (SubCommand)new StatsCommand());
        this.commands.put("lobby", (SubCommand)new LobbyCommand());
        this.commands.put("join", (SubCommand)new JoinCommand());
        this.commands.put("leave", (SubCommand)new LeaveCommand());
        this.commands.put("autojoin", (SubCommand)new AutoJoinCommand());
        this.commands.put("admin", (SubCommand)new AdminCommand());
        this.commands.put("create", (SubCommand)new CreateCommand());
        this.commands.put("delete", (SubCommand)new DeleteCommand());
        this.commands.put("setlocation", (SubCommand)new SetLocationCommand());
        this.commands.put("setgloballobby", (SubCommand)new SetGlobalLobby());
        this.commands.put("edit", (SubCommand)new EditCommand());
        this.commands.put("reset", (SubCommand)new ResetCommand());
        this.commands.put("start", (SubCommand)new StartCommand());
        this.commands.put("stop", (SubCommand)new StopCommand());
        this.commands.put("coins", (SubCommand)new CoinsCommand());
        this.commands.put("exp", (SubCommand)new ExpCommand());
        this.commands.put("setmodifier", (SubCommand)new SetModifierCommand());
        this.commands.put("powerup", (SubCommand)new PowerupCommand());
        this.commands.put("check", (SubCommand)new CheckCommand());
        this.commands.put("reload", (SubCommand)new ReloadCommand());
        this.commands.put("editmode", (SubCommand)new EditModeCommand());
        this.commands.put("test", (SubCommand)new TestCommand());
    }
    
    public boolean onCommand(final CommandSender var1, final Command var2, final String var3, final String[] var4) {
        final HideAndSeek var5 = HideAndSeek.getInstance();
        if (var1 instanceof final Player player) {
            Utils.playSound(player, "Command-Execute");
        }
        if (var4.length == 0) {
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + String.valueOf(ChatColor.STRIKETHROUGH) + "------------" + String.valueOf(ChatColor.GOLD) + " 躲猫猫 " + String.valueOf(ChatColor.GRAY) + "[" + var5.getDescription().getVersion() + "] " + String.valueOf(ChatColor.AQUA) + String.valueOf(ChatColor.STRIKETHROUGH) + "------------");
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/HideAndSeek | Has " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 主要指令");
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has List " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 显示房间列表");
            if (!Config.getInstance().bungeeEnabled) {
                var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has Join " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 加入一个新游戏");
                var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has Autojoin " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 加入最优的空闲游戏");
                var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has Leave " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 离开游戏");
            }
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has Stats " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 查看您的账户统计");
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has Lobby " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 传送你到总大厅");
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + " - " + String.valueOf(ChatColor.GOLD) + "/has " + String.valueOf(var1.hasPermission("hideandseek.admin") ? ChatColor.GREEN : ChatColor.RED) + "Admin " + String.valueOf(ChatColor.AQUA) + "->" + String.valueOf(ChatColor.GREEN) + " 显示管理员命令");
            var1.sendMessage(String.valueOf(ChatColor.AQUA) + String.valueOf(ChatColor.STRIKETHROUGH) + "---------------------------------------");
            return true;
        }
        final String var6 = var4[0].toLowerCase();
        final Customization var7 = var5.customization;
        SubCommand var8 = null;
        if (this.commands.containsKey(var6)) {
            var8 = this.commands.get(var6);
        }
        else {
            for (final String var10 : this.commands.keySet()) {
                if (var10.startsWith(var6)) {
                    var8 = this.commands.get(var10);
                    break;
                }
            }
            if (var8 == null) {
                var1.sendMessage((String)var7.messages.get("unknown_command"));
                return true;
            }
        }
        if (!var8.allowConsole && !(var1 instanceof Player)) {
            var1.sendMessage((String)var7.messages.get("no_console"));
            return true;
        }
        if (var8.permission != null && !var1.hasPermission(var8.permission)) {
            var1.sendMessage((String)var7.messages.get("no_permission"));
            return false;
        }
        final boolean var11 = var8.execute(var5, var7, var1, var4);
        if (!var11) {
            var1.sendMessage(var7.messages.get("command_usage").replace("%cmd%", var4[0]).replace("%usage%", var8.arguments));
        }
        return true;
    }
    
    public List<String> onTabComplete(final CommandSender var1, final Command var2, final String var3, final String[] var4) {
        if (var4.length == 1) {
            final ArrayList var5 = new ArrayList();
            for (final Map.Entry var7 : this.commands.entrySet()) {
                final SubCommand var8 = var7.getValue();
                if (var8.permission == null || var1.hasPermission(var8.permission)) {
                    var5.add(var7.getKey());
                }
            }
            return var5;
        }
        final String var9 = var4[0].toLowerCase();
        if (!var9.equals("join") && !var9.equals("start") && !var9.equals("stop") && !var9.equalsIgnoreCase("edit") && !var9.equals("check") && !var9.equals("setlocation")) {
            return null;
        }
        final ArrayList var10 = new ArrayList();
        for (final Arena var12 : Arena.arenaObjects) {
            var10.add(var12.name);
        }
        return var10;
    }
}
